    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * XIntervalDataItem.java
    029     * ----------------------
    030     * (C) Copyright 2006, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: XIntervalDataItem.java,v 1.1.2.2 2007/02/02 11:01:09 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 20-Oct-2006 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data.xy;
    044
    045    import org.jfree.data.ComparableObjectItem;
    046
    047    /**
    048     * An item representing data in the form (x, x-low, x-high, y).
    049     *
    050     * @since 1.0.3
    051     */
    052    public class XIntervalDataItem extends ComparableObjectItem {
    053
    054        /**
    055         * Creates a new instance of <code>XIntervalDataItem</code>.
    056         *
    057         * @param x  the x-value.
    058         * @param xLow  the lower bound of the x-interval.
    059         * @param xHigh  the upper bound of the x-interval.
    060         * @param y  the y-value.
    061         */
    062        public XIntervalDataItem(double x, double xLow, double xHigh, double y) {
    063            super(new Double(x), new YWithXInterval(y, xLow, xHigh));
    064        }
    065
    066        /**
    067         * Returns the x-value.
    068         *
    069         * @return The x-value (never <code>null</code>).
    070         */
    071        public Number getX() {
    072            return (Number) getComparable();
    073        }
    074
    075        /**
    076         * Returns the y-value.
    077         *
    078         * @return The y-value.
    079         */
    080        public double getYValue() {
    081            YWithXInterval interval = (YWithXInterval) getObject();
    082            if (interval != null) {
    083                return interval.getY();
    084            }
    085            else {
    086                return Double.NaN;
    087            }
    088        }
    089
    090        /**
    091         * Returns the lower bound of the x-interval.
    092         *
    093         * @return The lower bound of the x-interval.
    094         */
    095        public double getXLowValue() {
    096            YWithXInterval interval = (YWithXInterval) getObject();
    097            if (interval != null) {
    098                return interval.getXLow();
    099            }
    100            else {
    101                return Double.NaN;
    102            }
    103        }
    104
    105        /**
    106         * Returns the upper bound of the x-interval.
    107         *
    108         * @return The upper bound of the x-interval.
    109         */
    110        public double getXHighValue() {
    111            YWithXInterval interval = (YWithXInterval) getObject();
    112            if (interval != null) {
    113                return interval.getXHigh();
    114            }
    115            else {
    116                return Double.NaN;
    117            }
    118        }
    119
    120    }